import matplotlib.pyplot as plt
import numpy as np

alpha = np.linspace(0, 6.28, 100)
y = np.sin(alpha)

mm = 1./25.4 # scaling factor millimeter -> inch
fig = plt.figure(figsize=(250*mm, 180*mm))  # specify size in mm

plt.plot(alpha, y, label=r'$\sin(\alpha)$')
plt.xlabel(r'$\alpha$ in rad')
plt.ylabel('$y$')
plt.title('Sine Function')
plt.legend() # add legend
plt.grid() # toggle grid

plt.savefig('test.pdf') # file format is inferred from ending (.pdf)
plt.show() # display the figure
